/* gaussjordan4.c                   freeware                   xhunga@tiscali.fr
*/

/* --------------------------------- INCLUDES ------------------------------- */
#include "xa_hfile.h"
/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* Call  :                                                                    */
/* Debug :                                                                    */
/* -------------------------------------------------------------------------- */
void gjA()
{
fraction  a;
fraction  b;
fraction  c;
fraction  d;
fraction  L1;
fraction  L2;
fraction  det;
fraction  DetA;
fraction  TraceA;
fraction  amnsL1;
fraction  DetTrpsA;
fraction  TraceTrpsA;

double pbID     [2][2*TWOCOL];matrix mID      ={2,2*TWOCOL,&pbID     [0][0]};
double pbDetA_ID[2][2*TWOCOL];matrix mDetA_ID ={2,2*TWOCOL,&pbDetA_ID[0][0]};
double pbX      [2][2*TWOCOL];matrix mX       ={2,2*TWOCOL,&pbX      [0][0]};
double pbA      [2][2*TWOCOL];matrix mA       ={2,2*TWOCOL,&pbA      [0][0]};
double pAp2     [2][2*TWOCOL];matrix mAp2     ={2,2*TWOCOL,&pAp2     [0][0]};
double pTraceA_A[2][2*TWOCOL];matrix mTraceA_A={2,2*TWOCOL,&pTraceA_A[0][0]};
double pbx1     [2][  TWOCOL];matrix mx1      ={2,  TWOCOL,&pbx1     [0][0]};
double pbAx1    [2][  TWOCOL];matrix mAx1     ={2,  TWOCOL,&pbAx1    [0][0]};
double pbL1x1   [2][  TWOCOL];matrix mL1x1    ={2,  TWOCOL,&pbL1x1   [0][0]};

double pAp2_mns_TraceA_A  [2][2*TWOCOL];
matrix mAp2_mns_TraceA_A ={2, 2*TWOCOL,&pAp2_mns_TraceA_A[0][0]};
/*-------------------------------- PROGRAM ---------------------------------- */
    do
  {
    a =  rndF(9,1); b =  rndF(9,1); c =  rndF(9,1); d =  subF(addF(a,b),c);

   *(mA.pblock+0  *mA.cols+0) = a.numer; *(mA.pblock+0  *mA.cols+1) = a.denom;
   *(mA.pblock+0  *mA.cols+2) = b.numer; *(mA.pblock+0  *mA.cols+3) = b.denom;
   *(mA.pblock+1  *mA.cols+0) = c.numer; *(mA.pblock+1  *mA.cols+1) = c.denom;
   *(mA.pblock+1  *mA.cols+2) = d.numer; *(mA.pblock+1  *mA.cols+3) = d.denom;

    det = detF(&mA);

  }while(!det.numer);

                           L1 = subF(a,c);
                           L2 = addF(a,b);
                       amnsL1 = subF(a,L1);
  *(mx1.pblock+0 *mx1.cols+0) =     -b.numer;
  *(mx1.pblock+0 *mx1.cols+1) =      b.denom;
  *(mx1.pblock+1 *mx1.cols+0) = amnsL1.numer;
  *(mx1.pblock+1 *mx1.cols+1) = amnsL1.denom;

  clrscrn();
  printf("\n                                                  A :");
  printmI(&mA);
  TraceA = tracemF(&mA);
    DetA =    detF(&mA);
  printf("\n                 The characteristic equation of A is :\n");
  printf("\n                          L**2 - %4.0f L + %4.0f = 0  \n\n",
               TraceA.numer,     DetA.numer);

  printf("\n      The Cayley-Hamilton theorem say, that a square ");
  printf("\n      matrix A satisfies its characteristic equation\n");
  printf("\n                          A**2 - %4.0f A + %4.0f I = 0\n\n",
               TraceA.numer,     DetA.numer);
  getchar();

  clrscrn();
  printf("\n                                                A**2 :");
  powermF(&mA,2,&mAp2);
  printmI(&mAp2);
  printf("\n                                             %4.0f A :",TraceA.numer);
  smultmF(TraceA,&mA,&mTraceA_A);
  printmI(&mTraceA_A);
      mid(&mID);
  printf("\n                                             %4.0f I :",DetA.numer);
  smultmF(DetA,  &mID,&mDetA_ID);
  printmI(&mDetA_ID);
    submF(&mAp2, &mTraceA_A,&mAp2_mns_TraceA_A);
    addmF(&mAp2_mns_TraceA_A,&mDetA_ID,&mX);
  printf("\n                          A**2 - %4.0f A + %4.0f I = 0\n\n",
               TraceA.numer,     DetA.numer);
  printmF(&mX);
}

void hello(void)
{
  printf("\n Freeware by : xhunga bernard 06000 Nice France.\n");
  printf("\n\n\n\n\n                                          ");
  printf("\n        The Cayley-Hamilton theorem             \n");
  printf("\n                                                \n");
  printf("\n                *******                         \n");
  printf("\n\n\n\n\n\n                                        ");
  printf("\n Distributed  by :  http://www.simtel.net/        ");
  printf("\n                                                  ");
  printf("\n Press return to continue                         ");
  printf("\n                                                  ");

  getchar();
}


/* --------------------------------- MAIN ----------------------------------- */
int main()
{
time_t t;

/*-------------------------------- PROGRAM ---------------------------------- */
  srand(time(&t));
  hello();
do
{


  gjA();


printf("\n Press 'X' Return to stop\n");
} while(toupper(getchar())!='X');

  return 0;
}

